package cn.com.infosec.asn1.isismtt.x509;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERPrintableString;
import cn.com.infosec.asn1.DERSequence;
import java.math.BigInteger;
import java.util.Enumeration;

public class MonetaryLimit extends ASN1Encodable {
   DERPrintableString currency;
   DERInteger amount;
   DERInteger exponent;

   public static MonetaryLimit getInstance(Object obj) {
      if (obj != null && !(obj instanceof MonetaryLimit)) {
         if (obj instanceof ASN1Sequence) {
            return new MonetaryLimit(ASN1Sequence.getInstance(obj));
         } else {
            throw new IllegalArgumentException("unknown object in getInstance");
         }
      } else {
         return (MonetaryLimit)obj;
      }
   }

   private MonetaryLimit(ASN1Sequence seq) {
      if (seq.size() == 3) {
         MonetaryLimit var10000 = this;
         MonetaryLimit var10001 = this;
         Enumeration var2;
         this.currency = DERPrintableString.getInstance((var2 = seq.getObjects()).nextElement());
         var10001.amount = DERInteger.getInstance(var2.nextElement());
         var10000.exponent = DERInteger.getInstance(var2.nextElement());
      } else {
         throw new IllegalArgumentException("Bad sequence size: " + seq.size());
      }
   }

   public MonetaryLimit(String currency, int amount, int exponent) {
      MonetaryLimit var10000 = this;
      MonetaryLimit var10001 = this;
      MonetaryLimit var10002 = this;
      super();
      DERPrintableString var4;
      var4 = new DERPrintableString.<init>(currency, true);
      var10002.currency = var4;
      DERInteger var5;
      var5 = new DERInteger.<init>(amount);
      var10001.amount = var5;
      var5 = new DERInteger.<init>(exponent);
      var10000.exponent = var5;
   }

   public String getCurrency() {
      return this.currency.getString();
   }

   public BigInteger getAmount() {
      return this.amount.getValue();
   }

   public BigInteger getExponent() {
      return this.exponent.getValue();
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.currency);
      var1.add(this.amount);
      var10000.add(this.exponent);
      return new DERSequence(var1);
   }
}
